/*
 * Copyright (C) 2002-2007 Keisuke Nishida
 * Copyright (C) 2007 Roger While
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1,
 * or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; see the file COPYING.LIB.  If not write to
 * the Free Software Foundation, 51 Franklin Street, Fifth Floor
 * Boston, MA 02110-1301 USA
 */

#ifndef COB_CALL_H
#define COB_CALL_H

#include <setjmp.h>
#include <libcob/common.h>

struct cobjmp_buf {
	int	cbj_int[4];
	void	*cbj_ptr[4];
	jmp_buf	cbj_jmp_buf;
	void	*cbj_ptr_rest[2];
};

extern void	cob_set_cancel (const char *name, void *entry, void *cancel);
extern void	*cob_resolve (const char *name);
extern void	*cob_resolve_1 (const char *name);
extern const char *cob_resolve_error (void);

extern void	*cob_call_resolve (const cob_field *f);
extern void	*cob_call_resolve_1 (const cob_field *f);
extern void	cob_field_cancel (const cob_field *f);
extern void	cobcancel (const char *name);
extern int	cobcall (const char *name, const int argc, void **argv);
extern int	cobfunc (const char *name, const int argc, void **argv);
/*
extern int	cobsetjmp (struct cobjmp_buf *jbuf);
*/
extern void	*cobsavenv (struct cobjmp_buf *jbuf);
extern void	*cobsavenv2 (struct cobjmp_buf *jbuf, const int jsize);
extern void	coblongjmp (struct cobjmp_buf *jbuf);
#define	cobsetjmp(x)	setjmp (cobsavenv (x))

#ifdef __GNUC__
extern void cob_call_error (void) __attribute__ ((noreturn));
#else
extern void cob_call_error (void);
#endif

#endif /* COB_CALL_H */
